<template>
  <nav
    ref="navbar"
    class="navbar relative z-30 font-navbar lg:flex lg:justify-between"
    role="navigation"
    aria-label="main navigation"
  >
    <div class="flex items-center justify-between h-full">
      <navbar-brand-logo
        class="lg:hidden"
        v-bind="altLogo"
        @click="isOpen = false"
      />
      <navbar-brand-logo class="hidden lg:block" v-bind="logo" />
      <navbar-burger
        class="hamburger--squeeze lg:hidden"
        :active="isOpen"
        @click="isOpen = !isOpen"
      />
    </div>

    <navbar-menu-mobile
      v-if="isOpen"
      v-bind="navbarItems"
      @item-tapped="isOpen = false"
    />

    <navbar-menu-desktop class="hidden lg:block" v-bind="navbarItems" />
  </nav>
</template>

<script>
import {
  disableBodyScroll,
  enableBodyScroll,
  clearAllBodyScrollLocks,
} from 'body-scroll-lock';

import NavbarBrandLogo from './NavbarBrandLogo';
import NavbarBurger from './NavbarBurger';
import NavbarMenuMobile from './NavbarMenuMobile';
import NavbarMenuDesktop from './NavbarMenuDesktop';

export default {
  name: 'Navbar',
  components: {
    NavbarBrandLogo,
    NavbarBurger,
    NavbarMenuMobile,
    NavbarMenuDesktop,
  },
  inject: ['site'],
  data() {
    return {
      isOpen: false,
    };
  },
  computed: {
    routes() {
      return this.site.routes;
    },
    navbarItems() {
      const { navbar_menu } = this.site.navigation;
      return {
        items: navbar_menu.items.map(this.navItem),
        actions: navbar_menu.actions.map(this.navAction),
      };
    },
    logo() {
      const { image, description } = this.site.logos.primary;

      return {
        image: require(`!!assets-loader!../../../static${image}`),
        description,
      };
    },
    altLogo() {
      const { image, description } = this.site.logos.secondary;

      return {
        image: require(`!!assets-loader!../../../static${image}`),
        description,
      };
    },
  },
  watch: {
    isOpen: function(val) {
      val
        ? disableBodyScroll(this.$refs.navbar)
        : enableBodyScroll(this.$refs.navbar);
    },
  },
  beforeDestroy() {
    clearAllBodyScrollLocks();
  },
  methods: {
    navItem(item) {
      return {
        id: item.id,
        label: item.label,
        path: this.routes[item.id],
        children: item.children ? item.children.map(this.navItem) : [],
      };
    },
    navAction(action) {
      return {
        id: action.id,
        label: action.label,
        path: this.routes[action.id],
        btn: action.btn,
      };
    },
  },
};
</script>

<style lang="postcss" scoped>
.navbar {
  --navbar-h: var(--g-navbar-h, theme('spacing.20'));
  --navbar-px: var(--g-px);
  --navbar-text-size: theme('fontSize.base');
  --navbar-text-color: theme('colors.white');
  --navbar-bg-color: theme('colors.blue.700');
  --navbar-item-active-color: theme('colors.orange.100');
  --navbar-item-underline-color: theme('colors.orange.100');

  height: var(--navbar-h);
  width: 100%;
  padding-left: var(--navbar-px);
  padding-right: var(--navbar-px);
  font-size: var(--navbar-text-size);
  color: var(--navbar-text-color);
  background-color: var(--navbar-bg-color);
}
@screen md {
  .navbar {
    --navbar-px: var(--g-px-md);
  }
}
@screen lg {
  .navbar {
    --navbar-px: var(--g-px-lg);
    --navbar-text-size: theme('fontSize.sm');
    --navbar-text-color: var(--g-base-text-color);
    --navbar-bg-color: theme('colors.white');
    --navbar-item-active-color: theme('colors.blue.600');
    --navbar-item-underline-color: theme('colors.blue.600');
  }
}
@screen xl {
  .navbar {
    --navbar-px: var(--g-px-xl);
    --navbar-text-size: theme('fontSize.base');
  }
}
</style>
